=== modified file 'drizzled/item/type_holder.cc'
--- drizzled/item/type_holder.cc	2010-12-25 01:27:46 +0000
+++ drizzled/item/type_holder.cc	2011-02-11 09:39:17 +0000
@@ -207,6 +207,10 @@
 
   switch (item->field_type())
   {
+  case DRIZZLE_TYPE_TIME:
+  case DRIZZLE_TYPE_BOOLEAN:
+  case DRIZZLE_TYPE_UUID:
+  case DRIZZLE_TYPE_MICROTIME:
   case DRIZZLE_TYPE_TIMESTAMP:
   case DRIZZLE_TYPE_DATETIME:
   case DRIZZLE_TYPE_DATE:
@@ -214,7 +218,7 @@
   case DRIZZLE_TYPE_DECIMAL:
   case DRIZZLE_TYPE_ENUM:
   case DRIZZLE_TYPE_BLOB:
-    return 4;
+    return item->max_length;
   case DRIZZLE_TYPE_LONG:
     return MY_INT32_NUM_DECIMAL_DIGITS;
   case DRIZZLE_TYPE_DOUBLE:
@@ -223,10 +227,9 @@
     return 0;
   case DRIZZLE_TYPE_LONGLONG:
     return 20;
-  default:
-    assert(0); // we should never go there
-    return 0;
   }
+  assert(0);
+  abort();
 }
 
 

=== modified file 'tests/r/ctype_utf8.result'
--- tests/r/ctype_utf8.result	2010-09-02 18:35:05 +0000
+++ tests/r/ctype_utf8.result	2011-02-11 09:39:17 +0000
@@ -1097,11 +1097,11 @@
 SELECT '1' UNION SELECT '킱1234567890';
 1
 1
-킱
+킱1234567890
 SELECT 1 UNION SELECT '킱1234567890';
 1
 1
-킱1
+킱1234567890
 CREATE TABLE t1 (c VARCHAR(11));
 CREATE TABLE t2 (b CHAR(1), i INT);
 INSERT INTO t1 (c) VALUES ('킱1234567890');

=== modified file 'tests/r/func_concat.result'
--- tests/r/func_concat.result	2008-12-06 22:41:03 +0000
+++ tests/r/func_concat.result	2011-02-11 09:39:17 +0000
@@ -39,7 +39,7 @@
 select 'a' union select concat('a', -4.5);
 a
 a
-a-4.
+a-4.5
 select 'a' union select concat('a', -(4 + 1));
 a
 a
@@ -67,7 +67,7 @@
 select 'a' union select concat('a', -0.0000);
 a
 a
-a0.0
+a0.0000
 select concat((select x from (select 'a' as x) as t1 ),
 (select y from (select 'b' as y) as t2 )) from (select 1 union select 2 )
 as t3;

=== modified file 'tests/r/union.result'
--- tests/r/union.result	2011-02-07 17:20:59 +0000
+++ tests/r/union.result	2011-02-11 09:39:17 +0000
@@ -539,10 +539,11 @@
 select * from t1;
 a
 a
+aa
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` VARCHAR(1) COLLATE utf8_general_ci NOT NULL DEFAULT ''
+  `a` VARCHAR(2) COLLATE utf8_general_ci NOT NULL DEFAULT ''
 ) ENGINE=DEFAULT COLLATE = utf8_general_ci
 drop table t1;
 create table t1 SELECT 12 as a UNION select "aa" as a;
@@ -553,7 +554,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` VARBINARY(4) NOT NULL DEFAULT ''
+  `a` VARBINARY(8) NOT NULL DEFAULT ''
 ) ENGINE=DEFAULT COLLATE = utf8_general_ci
 drop table t1;
 create table t1 SELECT 12 as a UNION select 12.2 as a;
@@ -665,7 +666,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `dt` VARBINARY(19) DEFAULT NULL
+  `dt` VARBINARY(40) DEFAULT NULL
 ) ENGINE=DEFAULT COLLATE = utf8_general_ci
 drop table t1;
 create table t1 SELECT dt from t2 UNION select sv from t2;
@@ -765,7 +766,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `test` VARCHAR(4) COLLATE utf8_general_ci NOT NULL DEFAULT ''
+  `test` VARCHAR(5) COLLATE utf8_general_ci NOT NULL DEFAULT ''
 ) ENGINE=DEFAULT COLLATE = utf8_general_ci
 drop table t1;
 create table t1 (s char(200));
@@ -1195,7 +1196,7 @@
 show create table t2;
 Table	Create Table
 t2	CREATE TABLE `t2` (
-  `a` VARCHAR(5) COLLATE utf8_general_ci DEFAULT NULL
+  `a` VARCHAR(12) COLLATE utf8_general_ci DEFAULT NULL
 ) ENGINE=DEFAULT COLLATE = utf8_general_ci
 select row_format from data_dictionary.TABLES where table_schema="test" and table_name="t2";
 row_format
@@ -1203,7 +1204,7 @@
 show create table t2;
 Table	Create Table
 t2	CREATE TABLE `t2` (
-  `a` VARCHAR(5) COLLATE utf8_general_ci DEFAULT NULL
+  `a` VARCHAR(12) COLLATE utf8_general_ci DEFAULT NULL
 ) ENGINE=DEFAULT COLLATE = utf8_general_ci
 drop table t1,t2;
 CREATE TABLE t1 (a mediumtext);
@@ -1358,6 +1359,7 @@
 select '12' union select '12345';
 12
 12
+12345
 CREATE TABLE t1 (a int);
 INSERT INTO t1 VALUES (3),(1),(2),(4),(1);
 SELECT a FROM (SELECT a FROM t1 UNION SELECT a FROM t1 ORDER BY a) AS test;

